#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 
#include <math.h>

#pragma comment( lib, "../bin/pdfpage.lib" )

extern "C" __declspec(dllexport) int __stdcall VerySplitMergePDF(char *lpCommandLine);
extern "C" __declspec(dllexport) int __stdcall VeryAppendPDF(char *ptrExistingPDFName,char *ptrAppendPDF);
extern "C" __declspec(dllexport) int __stdcall VerySplitMergePDFEx(char *lpInputPDF,char *lpPageRange,char *lpOutPDF);
extern "C" __declspec(dllexport) int __stdcall VeryGetPDFFilePageCount(const char *input);
extern "C" __declspec(dllexport) int __stdcall VerySplitMergeSetParameter(const char *key,const char *value);
extern "C" __declspec(dllexport) int __stdcall VeryGetPDFFilePageCountFast(const char *input);

int TestSpeed(int mode, const char *szInputPDFFile)
{
	int iPageCount = 0;
	for(int i = 0; i < 1; i++)
	{
		int iTickCountBegin = GetTickCount();
		if(mode == 0)
			iPageCount = VeryGetPDFFilePageCount(szInputPDFFile);
		else
			iPageCount = VeryGetPDFFilePageCountFast(szInputPDFFile);
		int iTickCountEnd = GetTickCount();
		if(i == 0)
			printf("%s contains %d pages.\n",szInputPDFFile,iPageCount);
		printf("%s run at %dms\n",mode==0?"VeryGetPDFFilePageCount()":"VeryGetPDFFilePageCountFast()", 
			iTickCountEnd-iTickCountBegin);
	}
	printf("------------------------------------\n");
	return iPageCount;
}
void main(int argc,char *argv[])
{
	BOOL bRet;
	char szInputPDFFile[256];
	char szOutputPDFFile[256];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[MAX_PATH];
	char ext[_MAX_EXT];

	if(argc != 2)
		return;
	//VerySplitMergeSetParameter("RetainBookmarks","on");
	//VerySplitMergeSetParameter("RetainAcroForms","off");
	VerySplitMergeSetParameter("RetainBookmarks","off");
	VerySplitMergeSetParameter("RetainAcroForms","on");
	
	strcpy(szInputPDFFile,argv[1]);
	_splitpath( szInputPDFFile, drive, dir, fname, ext );
	strcat(fname,"_out");
	_makepath( szOutputPDFFile, drive, dir, fname, ext);

	TestSpeed(0,szInputPDFFile);
	TestSpeed(1,szInputPDFFile);
	//Split and merge pdf files
	bRet = VerySplitMergePDFEx(szInputPDFFile,"1,3",szOutputPDFFile);

//	bRet = VeryAppendPDF(szOutputPDFFile,szInputPDFFile);
//	_makepath( szOutputPDFFile, drive, dir, fname, "");
//	bRet = VerySplitMergePDFEx(szInputPDFFile,"burst",szOutputPDFFile);
	printf("Press any key to continue......\n");
	getchar();
}